package de.ozgcloud.apilib.common.command;

import java.util.Set;

import de.itvsh.kop.common.datatype.StringBasedValue;
import lombok.EqualsAndHashCode;

@EqualsAndHashCode(callSuper = true)
public class OzgCloudCommandStatus extends StringBasedValue {

	public static final OzgCloudCommandStatus PENDING = new OzgCloudCommandStatus("PENDING");
	public static final OzgCloudCommandStatus FINISHED = new OzgCloudCommandStatus("FINISHED");
	public static final OzgCloudCommandStatus ERROR = new OzgCloudCommandStatus("ERROR");
	public static final OzgCloudCommandStatus REVOKE_PENDING = new OzgCloudCommandStatus("REVOKE_PENDING");
	public static final OzgCloudCommandStatus REVOKED = new OzgCloudCommandStatus("REVOKED");

	private static final Set<OzgCloudCommandStatus> FINAL_STATES = Set.of(FINISHED, ERROR, REVOKED);

	OzgCloudCommandStatus(String status) {
		super(status);
	}

	public static OzgCloudCommandStatus from(String status) {
		return new OzgCloudCommandStatus(status);
	}

	public boolean isFinalState() {
		return FINAL_STATES.contains(this);
	}
}
