package de.ozgcloud.apilib.common.command.grpc;

import java.util.Objects;
import java.util.Optional;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

import de.itvsh.kop.common.datatype.StringBasedValue;
import de.ozgcloud.apilib.common.command.OzgCloudCommand;
import de.ozgcloud.vorgang.common.grpc.GrpcObjectMapper;
import de.ozgcloud.vorgang.grpc.command.GrpcCreateCommandRequest;

@Mapper(uses = GrpcObjectMapper.class)
public interface OzgCloudCommandMapper {

	@Mapping(target = "mergeFrom", ignore = true)
	@Mapping(target = "clearField", ignore = true)
	@Mapping(target = "clearOneof", ignore = true)
	@Mapping(target = "mergeBodyObj", ignore = true)
	@Mapping(target = "mergeCallContext", ignore = true)
	@Mapping(target = "mergeRedirectRequest", ignore = true)
	@Mapping(target = "mergeUnknownFields", ignore = true)
	@Mapping(target = "removeBody", ignore = true)
	@Mapping(target = "callContext", ignore = true)

	@Mapping(target = "orderStringBytes", ignore = true)
	@Mapping(target = "order", ignore = true)
	@Mapping(target = "orderValue", ignore = true)
	@Mapping(target = "redirectRequest", ignore = true)
	@Mapping(target = "relationIdBytes", ignore = true)
	@Mapping(target = "unknownFields", ignore = true)
	@Mapping(target = "vorgangIdBytes", ignore = true)
	@Mapping(target = "allFields", ignore = true)
	@Mapping(target = "bodyBuilderList", ignore = true)
	@Mapping(target = "bodyList", ignore = true)
	@Mapping(target = "bodyOrBuilderList", ignore = true)

	@Mapping(target = "bodyObj", source = "bodyObject")
	@Mapping(target = "orderString", source = "order")
	GrpcCreateCommandRequest toCreateRequest(OzgCloudCommand command);

	default String toString(StringBasedValue stringBasedValue) {
		return Optional.ofNullable(stringBasedValue).map(Objects::toString).orElse(null);
	}
}
